
#   setToCurrentDate
#   ----------------
#   Set the field to the current date. Default format is '%d-%b-%y'
#   but can be overridden.
#
def setToCurrentDate (self, format = None, row = None) :

    import time
    if row    is None : row = self.getBlock().getQueryRow()
    if format is None or format == '' : format = '%d-%b-%y'
    self.setValue (row, time.strftime (format, time.localtime(time.time())))

#   setToCurrentTime
#   ----------------
#   Set the field to the current time. Default format is '%H:%M:%S'
#   but can be overridden.
#
def setToCurrentTime (self, format = None, row = None) :

    import time
    if row    is None : row = self.getBlock().getQueryRow()
    if format is None or format == '' : format = '%H:%M:%S'
    self.setValue (row, time.strftime (format, time.localtime(time.time())))


#   Standard import code. Done this way to work both with Rekall itself
#   and with rekallWeb.
#   -------------------
#
def setAsMethods (klass) :
    setattr (klass, 'setToDate', setToDate)
    setattr (klass, 'setToTime', setToTime)

try    :
    import Rekall
    setAsMethods (Rekall.PyKBField)
except :
    pass
