
#   setValueFromQuery
#   -----------------
#   Set the control value to the first value retured by a query. If
#   no row is specified then the value for the current row is
#   updated
#
def setValueFromQuery (self, query, args = [], row = None, dbname = '') :

    import RekallPYDBI
    cursor = RekallPYDBI.connect (self, dbname).cursor()
    cursor.execute (query, args)

    try    : value = cursor.fetchone()[0]
    except : value = None

    if row is None : row = self.getBlock().getQueryRow()
    self.setValue (row, value)


#   Standard import code. Done this way to work both with Rekall itself
#   and with rekallWeb.
#   -------------------
#
def setAsMethods (klass) :
    setattr (klass, 'setValueFromQuery', setValueFromQuery)

try    :
    import Rekall
    setAsMethods (Rekall.PyKBItem)
except :
    pass
