
#   cursor
#   ------
#   Allocate and return a cursor on the database containing the object.
#   If a query is given, this is executed; the arguments are optional.
#
def cursor (self, query = None, args = None, dbname = '') :

    import RekallPYDBI
    c = RekallPYDBI.connect (self, dbname).cursor()
    if query is not None :
        if args is None : args = []
        c.execute (query, args)
    return c


#   Standard import code. Done this way to work both with Rekall itself
#   and with rekallWeb.
#   -------------------
#
def setAsMethods (klass) :
    setattr (klass, 'cursor', cursor)

try    :
    import Rekall
    setAsMethods (Rekall.PyKBObject)
except :
    pass
